## ghc 7.6.3

=== bindisttest/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

.PHONY: default_target

default_target: all

# Ideally we'd just include something to give us variables
# for paths and arguments to tools etc, and those set in mk/build.mk.
TOP=..
include $(TOP)/mk/tree.mk
include $(TOP)/mk/config.mk

ifeq "$(TEST_PREP)" "YES"
BIN_DIST_TEST_TAR_BZ2 = ../$(BIN_DIST_PREP_TAR_BZ2)
else
BIN_DIST_TEST_TAR_BZ2 = ../$(BIN_DIST_TAR_BZ2)
endif

all:
	"$(RM)" $(RM_OPTS_REC) $(BIN_DIST_INST_SUBDIR)
	"$(RM)" $(RM_OPTS_REC) a/b/c/*
	"$(RM)" $(RM_OPTS) HelloWorld HelloWorld.o HelloWorld.hi output
# We use the a/b/c subdirectory as configure looks for install-sh in
# . .. ../.. and we don't want it to find the build system's install-sh.
#
# NB. tar has funny interpretation of filenames sometimes (thinking
# c:/foo is a remote file), so it's safer to bzip and then pipe into
# tar rather than using tar -xjf:
	cd a/b/c/ && $(BZIP2_CMD) -cd ../../../$(BIN_DIST_TEST_TAR_BZ2) | $(TAR_CMD) -xf -
ifeq "$(Windows)" "YES"
	mv a/b/c/$(BIN_DIST_NAME) $(BIN_DIST_INST_DIR)
else
	cd a/b/c/$(BIN_DIST_NAME) && ./configure --prefix=$(BIN_DIST_INST_DIR)
	cd a/b/c/$(BIN_DIST_NAME) && $(MAKE) install
endif
	$(BIN_DIST_INST_DIR)/bin/runghc HelloWorld > output
	$(CONTEXT_DIFF) output expected_output
	$(BIN_DIST_INST_DIR)/bin/ghc --make HelloWorld
	./HelloWorld > output
	$(CONTEXT_DIFF) output expected_output
# Without --no-user-package-db we might pick up random packages from ~/.ghc
	$(BIN_DIST_INST_DIR)/bin/ghc-pkg check --no-user-package-db

clean distclean:
	"$(RM)" $(RM_OPTS_REC) $(BIN_DIST_INST_SUBDIR)
	"$(RM)" $(RM_OPTS_REC) a/b/c/*
	"$(RM)" $(RM_OPTS) HelloWorld HelloWorld.o HelloWorld.hi output

# Ignore a load of other standard targets
install install-docs doc:
	@:

show:
	@echo '$(VALUE)="$($(VALUE))"'

=== ghc/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = ghc

include ../mk/compiler-ghc.mk

=== includes/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = includes
TOP = ..
include $(TOP)/mk/sub-makefile.mk

=== libffi/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = libffi
TOP = ..
include $(TOP)/mk/sub-makefile.mk

=== rts/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = rts
TOP = ..
include $(TOP)/mk/sub-makefile.mk

FAST_MAKE_OPTS += stage=none

=== utils/Makefile ===
TOP=..
include $(TOP)/mk/boilerplate.mk

ifeq "$(DOING_BIN_DIST)" "YES"
# We're doing a binary-dist, descend into a subset of the dirs.
SUBDIRS = mkdirhier hp2ps parallel unlit
else
ifeq "$(BootingFromHc)" "YES"
SUBDIRS = mkdependC mkdirhier runstdtest genapply genprimopcode unlit
else
SUBDIRS = mkdependC mkdirhier runstdtest hp2ps \
	  parallel unlit genprimopcode genapply
endif
#ifneq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
## lndir doesn't build on Windows
#SUBDIRS += lndir
#endif
endif

ifeq "$(TARGETPLATFORM)" "i386-unknown-mingw32"
SUBDIRS += touchy
endif

# XXX pwd and lndir building disabled for now

# Utils that we don't build by default:
#	nofib-analyse

# Utils that are old and/or bitrotted:
#	stat2resid
#	debugNCG
#	genargs
#	heap-view
#	pvm
#	verbatim
#	ltx
#	hstags

# "heap-view" is not in the list because (a) it requires
#  a Haskell compiler (which you may not have yet), and (b) you are
#  unlikely to want it desperately.  It is easy to build once you have
#  a Haskell compiler and if you want it.

include $(TOP)/mk/target.mk

# genprimopcode is needed to boot in ghc/compiler...
ifneq "$(BootingFromHc)" "YES"
boot ::
	$(MAKE) -C genprimopcode
endif

############################################

# The utils may be built with the bootstrapping compiler, for use during
# the build, or with the stage2 compiler, for installing. Some of them
# are built with both; we can't install the utils built with the
# bootstrapping compiler as they may use different versions of C
# libraries. The reason we use stage2 rather than stage1 is that some
# utils, e.g. haddock, need the GHC API package.

WITH_BOOTSTRAPPING_COMPILER = installPackage ghc-pkg hsc2hs hpc

WITH_STAGE2 = installPackage ghc-pkg runghc hpc pwd haddock
ifneq "$(NO_INSTALL_HSC2HS)" "YES"
WITH_STAGE2 += hsc2hs
endif

# sort removes duplicates - we don't actually care about the order
WITH_EITHER = $(sort $(WITH_BOOTSTRAPPING_COMPILER) $(WITH_STAGE2))

# We need to build pwd with stage 2, as it goes in bindists, but we
# don't actually want to install it. Likewise the installPackage
# program.
DO_NOT_INSTALL = pwd installPackage

binary-dist: $(foreach P,$(WITH_STAGE2),binary-dist.$P)
ifeq "$(WHERE_AM_I)" ""
	echo "I don't know where I am" >&2
	exit 1
endif
	echo $(WHERE_AM_I)/Makefile >> $(BIN_DIST_LIST)
	set -e; for d in $(SUBDIRS); do $(MAKE) -C $$d binary-dist WHERE_AM_I=$(WHERE_AM_I)/$$d; done

clean:: $(foreach P,$(WITH_EITHER),clean.$P)

distclean:: $(foreach P,$(WITH_EITHER),distclean.$P)

with-bootstrapping-compiler: \
    $(foreach P,$(WITH_BOOTSTRAPPING_COMPILER),with-bootstrapping-compiler.$P)

with-stage-2: $(foreach P,$(WITH_STAGE2),with-stage-2.$P)
	$(MAKE) -C haddock install-inplace

install:: $(foreach P,$(filter-out $(DO_NOT_INSTALL),$(WITH_STAGE2)),install.$P)

$(foreach P,$(WITH_EITHER),clean.$P): \
clean.%:
	$(MAKE) -C $* clean

$(foreach P,$(WITH_EITHER),distclean.$P): \
distclean.%:
	$(MAKE) -C $* distclean

$(foreach P,$(WITH_BOOTSTRAPPING_COMPILER),with-bootstrapping-compiler.$P): \
with-bootstrapping-compiler.%:
	$(MAKE) -C $* with-bootstrapping-compiler

$(foreach P,$(WITH_STAGE2),with-stage-2.$P): \
with-stage-2.%:
	$(MAKE) -C $* with-stage-2

$(foreach P,$(WITH_STAGE2),install.$P): \
install.%:
	$(MAKE) -C $* install

$(foreach P,$(WITH_STAGE2),binary-dist.$P): \
binary-dist.%:
	$(MAKE) -C $* binary-dist WHERE_AM_I=$(WHERE_AM_I)/$*

=== distrib/MacFrameworks/Makefile ===
READLINE_DIR = readline-5.2
GMP_DIR = gmp-4.2.1

all: GMP.framework GNUreadline.framework

$(GMP_DIR).tar.gz:
	cp ../../gmp/$(GMP_DIR).tar.gz .

$(READLINE_DIR).tar.gz:
	curl -O ftp://ftp.cwru.edu/pub/bash/$(READLINE_DIR).tar.gz

$(GMP_DIR): $(GMP_DIR).tar.gz
	tar -xzvf $(GMP_DIR).tar.gz

$(READLINE_DIR): $(READLINE_DIR).tar.gz
	tar -xzvf $(READLINE_DIR).tar.gz

GMP.framework: $(GMP_DIR)
	sh build-framework-gmp.sh

GNUreadline.framework: $(READLINE_DIR)
	sh build-framework-readline.sh

clean: 
	rm -rf $(GMP_DIR) $(READLINE_DIR)
	rm -rf 	GMP.framework GNUreadline.framework
	rm -rf 	GMP-framework.zip GNUreadline-framework.zip

cleanall: clean
	rm -f $(GMP_DIR).tar.gz
	rm -f $(READLINE_DIR).tar.gz

=== distrib/compare/Makefile ===

GHC = ghc

compare: *.hs
	"$(GHC)" -O --make -Wall -Werror $@

.PHONY: clean
clean:
	rm -f *.o
	rm -f *.hi
	rm -f compare compare.exe

=== docs/vh/Makefile ===
TOP = ../..
include $(TOP)/mk/boilerplate.mk

XML_DOC = vh
INSTALL_XML_DOC = vh

include $(TOP)/mk/target.mk

=== utils/genprimopcode/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = utils/genprimopcode
TOP = ../..
include $(TOP)/mk/sub-makefile.mk

=== utils/ghc-cabal/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2011 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = utils/ghc-cabal
TOP = ../..
include $(TOP)/mk/sub-makefile.mk

=== utils/hp2ps/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = utils/hp2ps
TOP = ../..
include $(TOP)/mk/sub-makefile.mk

=== debian/changelog ===
ghc (7.6.3-4) unstable; urgency=low

  [ Colin Watson ]
  * Enable verbose build output (see
    http://lists.debian.org/debian-devel/2013/06/msg00539.html).

  [ Gianfranco Costamagna ]

  * Switch to llvm (Closes: #711948)
  * removed deprecated DM-Upload-Allowed
  * removed some version checks, higher versions are already in oldstable.
  * Added dpkg-buildflags as build-dep, fixing lintian warning.

 -- Joachim Breitner <nomeata@debian.org>  Fri, 16 Aug 2013 14:40:37 +0200

ghc (7.6.3-3) unstable; urgency=low

  * Add patches/Handle-sign-bit-when-generating-veneer-for-ARM-Thumb.patch,
    patch by Colin Watson
  * Disable GHCi on arm, as it is severly borken (for more information see
    http://hackage.haskell.org/trac/ghc/ticket/7794)
  * Do not create system-wide documentation index if /usr/share/doc is
    missing. (Closes: #709911)
  * Create a symlink from prof_scc.png to prof_scc (Closes: #664043) 

 -- Joachim Breitner <nomeata@debian.org>  Wed, 05 Jun 2013 20:57:49 +0200

ghc (7.6.3-2) unstable; urgency=low

  * Enable compat level 9
  * Remove transitional ghc6-* packages 

 -- Joachim Breitner <nomeata@debian.org>  Fri, 24 May 2013 11:12:19 +0200

ghc (7.6.3-1) experimental; urgency=low

  * New upstream release

 -- Joachim Breitner <nomeata@debian.org>  Sun, 21 Apr 2013 19:12:24 +0200

=== debian/control ===
Source: ghc
Section: haskell
Priority: extra
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Joachim Breitner <nomeata@debian.org>,
 Erik de Castro Lopo <erikd@mega-nerd.com>
Standards-Version: 3.9.4
Build-Depends:
  debhelper (>= 9),
  libgmp-dev,
  devscripts,
  ghc,
  grep-dctrl,
  dh-autoreconf,
  gcc,
  llvm [armel armhf],
  libffi-dev,
  pkg-config,
  xsltproc,
  docbook-xsl,
  docbook-xml,
  binutils [armel armhf],
  libncurses5-dev,
  dpkg-dev (>= 1.16.1.1)
Build-Depends-Indep:
  hscolour,
  fop
Build-Conflicts:
  ccache
Homepage: http://haskell.org/ghc/
Vcs-Darcs: http://darcs.debian.org/pkg-haskell/ghc
Vcs-Browser: http://darcs.debian.org/cgi-bin/darcsweb.cgi?r=pkg-haskell/ghc

Package: ghc
Architecture: any
Depends: gcc, llvm [armel armhf], libgmp-dev, libffi-dev, libbsd-dev, libc6-dev, ${shlibs:Depends}, ${misc:Depends}
Provides: haskell-compiler, ${provided-devs}, ${haskell:Provides}, ${ghci}
Replaces: ghc6 (<< 7)
Conflicts: ghc6 (<< 7), ${provided-devs}
Breaks: cabal-install (<< 0.8.0), haskell-devscripts (<< 0.8.13), ghc-doc (<= 6.12.1-8)
Suggests: perl, ghc-prof, ghc-doc, haskell-doc, llvm
Description: The Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.

Package: ghc-prof
Architecture: any
Provides: ${provided-profs}, ${haskell:Provides}
Depends: ghc (= ${binary:Version}), ${misc:Depends}
Replaces: ghc6-prof (<< 7)
Conflicts: ghc6-prof (<< 7)
Description: Profiling libraries for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package contains additional profiling libraries. They are only needed,
 if you want to take a closer look on where exactly your program burns CPU
 cycles.

Package: ghc-doc
Section: doc
Architecture: all
Suggests: haskell-doc
Provides: ${provided-docs}
Replaces: ghc6-doc (<< 7), libghc-binary-doc
Conflicts: ghc6-doc (<< 7), ghc (<= 7.0.3-1), libghc-binary-doc
Depends: ${haddock:Depends}, ${misc:Depends}, perl
Description: Documentation for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package includes HTML, DVI and PS versions of the SGML-based
 documentation around GHC.

Package: ghc-dynamic
Architecture: i386 amd64
Depends: ghc (= ${binary:Version}), ${misc:Depends}
Description: Dynamic libraries for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package has dynamically linkable, shared versions of the
 libraries included with GHC.  Currently, they are available only on
 i386 and amd64 architectures.

Package: ghc-haddock
Architecture: any
Provides: haddock, ${haddock:Provides}
Conflicts: haddock
Depends: ghc (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Homepage: http://www.haskell.org/haddock/
Description: Documentation tool for annotated Haskell source code
 Haddock is a tool for automatically generating documentation from
 annotated Haskell source code.  It is primary intended for documenting
 libraries, but it should be useful for any kind of Haskell code.
 .
 Haddock lets you write documentation annotations next to the
 definitions of functions and types in the source code, in a syntax
 that is easy on the eye when writing the source code (no heavyweight
 mark-up).  The documentation generated by Haddock is fully hyperlinked:
 click on a type name in a type signature to go straight to the
 definition, and documentation, for that type.
 .
 Haddock can generate documentation in multiple formats; currently HTML
 is implemented, and there is partial support for generating DocBook.
 .
 This package contains Haddock version 2.10.0.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# This file is public domain software, originally written by Joey Hess.
#
# This version is for a multibinary package. It also allows you to build any
# of the binary packages independantly, via binary-<package> targets.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Set default flags with dpkg-buildflags
# This might also close #712228
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Set a dummy HOME variable upon build. Some build daemons do not set HOME, but
# ghc-cabal expects it to be available.
export HOME = /homedoesnotexistatbuildtime

# From /usr/share/doc/autotools-dev/examples/rules.gz:
export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
# Commented out for now.  The build scripts don't recognise i486 as an
# architecture and cross compiling isn't supported anyway.
#ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
#  confflags += --build $(DEB_HOST_GNU_TYPE)
#else
#  confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
#endif

ProjectVersion=$(shell cat VERSION)

GHC=$(firstword $(shell bash -c "type -p ghc"))
EXTRA_CONFIGURE_FLAGS=--with-ghc="$(GHC)"
BUILD_HADDOCK_DOCS=YES
DEB_HOOGLE_TXT_DIR = /usr/lib/ghc-doc/hoogle/

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	dh_autoreconf

	rm -f mk/build.mk
	echo "SRC_HC_OPTS += -lffi -optl-pthread" >> mk/build.mk
	echo "HADDOCK_DOCS := YES" >> mk/build.mk
	echo "XSLTPROC_OPTS += --nonet" >> mk/build.mk
ifneq (,$(findstring $(DEB_HOST_ARCH), arm armel armhf))
	echo "SRC_HC_OPTS     += -optc-mlong-calls" >> mk/build.mk
endif
ifeq (armhf,$(DEB_HOST_ARCH))
	echo "SRC_HC_OPTS += -D__ARM_PCS_VFP" >> mk/build.mk
endif
# proper fix for #360177
ifeq (ppc64,$(DEB_HOST_ARCH))
	echo "SRC_HC_OPTS += -optc-mminimal-toc" >> mk/build.mk
endif
ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
#	echo "GhcStage1HcOpts += -DDEBUG" >> mk/build.mk
#	echo "GhcStage2HcOpts += -DDEBUG" >> mk/build.mk
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -Rghc-timing -DDEBUG" >> mk/build.mk
#	echo "GhcLibHcOpts  += -O -dcore-lint -keep-hc-files " >> mk/build.mk
	echo "SplitObjs     = NO" >> mk/build.mk
	echo "STRIP         = :" >> mk/build.mk
endif
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -O0" >> mk/build.mk
	# This breaks the build - to be investigated:
	# echo "GhcLibHcOpts  += -O0" >> mk/build.mk
	echo "GhcRtsCcOpts  += -O0" >> mk/build.mk
endif
	# We also want to build the threaded profiling-enabled debug runtime,
	# because it does no harm
	echo 'GhcRTSWays += $$(if $$(findstring p, $$(GhcLibWays)),thr_debug_p,)' >> mk/build.mk
ifneq (,$(findstring $(DEB_HOST_ARCH),armel armhf))
	# GHCi is too badly broken on ARM; see
	# http://hackage.haskell.org/trac/ghc/ticket/7794
	echo "GhcWithInterpreter = NO" >> mk/build.mk
endif
	
	# We can't do this with a configure flag in 6.8.1 as libdir is not
	# defined at the point at which we := it
	echo 'ghclibdir := $${libdir}/ghc' >> mk/build.mk
	echo 'bindir  := $${ghclibdir}/bin' >> mk/build.mk
	echo 'ghclibexecdir := $${ghclibdir}/lib' >> mk/build.mk
	# docdir doesn't have a configure flag, and unfortunately
	# we also need to explicitly define all of its dependents as they
	# are set with :=
	echo 'docdir  := $$(datarootdir)/doc/ghc-doc' >> mk/build.mk
	echo 'htmldir := $$(docdir)'                   >> mk/build.mk
	echo 'dvidir  := $$(docdir)'                   >> mk/build.mk
	echo 'pdfdir  := $$(docdir)'                   >> mk/build.mk
	echo 'psdir   := $$(docdir)'                   >> mk/build.mk
	# We want verbose builds
	echo 'V=1'                                     >> mk/build.mk
	rm -f config.sub
	rm -f config.guess
	ln -s /usr/share/misc/config.sub .
	ln -s /usr/share/misc/config.guess .
	./configure $(confflags) --prefix=/usr \
		$(EXTRA_CONFIGURE_FLAGS) \
		--with-ld=ld.bfd \
		--with-llc=llc \
		--with-opt=opt

	touch $@

build: build-stamp
build-stamp: configure-stamp
	dh_testdir
	$(MAKE) $(MAKEFLAGS)

	# Do some very simple tests that the compiler actually works
	rm -rf debian/testghc
	mkdir debian/testghc
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo -O2
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*

# build haddock separately and hard code paths according to install paths
	mkdir -p debian/haddock-build
	cp -r utils/haddock debian/haddock-build
	cd debian/haddock-build/haddock; \
	        rm -rf dist; \
		../../../inplace/bin/ghc-stage2 --make Setup.lhs; \
		./Setup configure --prefix=/usr --with-compiler=../../../inplace/bin/ghc-stage2 \
			--package-db=../../../inplace/lib/package.conf.d/ \
			--htmldir=/usr/share/doc/ghc-haddock/html/ ; \
		./Setup build

	touch $@

FILES = \( -type f -o -type l \)
PROF_FILE = \( -name "*.p_*" -o -name "lib*_p.a" \)
DYNAMIC_FILE = \( -name "*.dyn_hi" -o -name lib*.so \)

install: install-stamp
install-stamp: build-stamp
	dh_testdir
	dh_testroot
	dh_prep

	# Install the basic stuff
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install

	# Delete all the library LICENSE files
	rm -f debian/tmp/usr/share/doc/ghc-doc/html/libraries/*/LICENSE

	# Generate lintian overrides
	mkdir -p debian/tmp/usr/share/lintian/overrides
	echo "ghc binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc-*/Cabal-*/Distribution/License.hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
	echo "ghc: extra-license-file `cl debian/tmp && echo usr/lib/ghc-*/Cabal-*/Distribution/License.dyn_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
	echo "ghc-prof binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc-*/Cabal-*/Distribution/License.p_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc-prof

	# Sort out the package.conf files
	mkdir -p debian/tmp/var/lib/ghc
	# Old directories for symlink-workaround. Remove once all libraries use new path
	mv debian/tmp/usr/lib/ghc/package.conf.d \
	   debian/tmp/var/lib/ghc/
	rm debian/tmp/var/lib/ghc/package.conf.d/package.cache
	chmod +x debian/provided_substvars
	debian/provided_substvars
	sed -ri 's,^haddock-interfaces: /.*?/libraries/,haddock-interfaces: /usr/lib/ghc-doc/haddock/,' debian/tmp/var/lib/ghc/package.conf.d/*.conf

	# Remove haddock as built within the ghc tree
	rm -f debian/tmp/usr/lib/ghc/bin/haddock \
	      debian/tmp/usr/lib/ghc/bin/haddock-$(ProjectVersion) \
	      debian/tmp/usr/lib/ghc/lib/haddock
	rm -rf debian/tmp/usr/lib/ghc/html

	# Sort out the binaries
	mkdir -p debian/tmp/usr/bin
	if inplace/bin/ghc-stage2 --info | grep '"Have interpreter","NO"'; then \
	    cd debian/tmp/usr/lib/ghc ;rm -f bin/ghci* bin/runghc* bin/runhaskell*; \
	fi
	cd debian/tmp/usr/lib/ghc/bin && \
	    for f in *; \
	    do ln -s /usr/lib/ghc/bin/$$f \
	             ../../../bin/$${f}; \
	    done
	sed -i 's,topdir="/usr/lib,topdir="/var/lib,' debian/tmp/usr/lib/ghc/bin/ghc-pkg-$(ProjectVersion)
	cd debian/haddock-build/haddock; ./Setup copy --dest=../../tmp

	# Check if we have a ghci binary
	if test -e debian/tmp/usr/lib/ghc/bin/ghci-$(ProjectVersion); then \
	    echo 'ghci=ghc-ghci' >> debian/ghc.substvars ; fi

	# Add haddock substvars
	echo "haddock:Depends=haddock-interface-$$(debian/tmp/usr/bin/haddock --interface-version)" >> debian/ghc-doc.substvars

## ghc 7.8.4

=== Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

ifeq "$(wildcard distrib/)" ""

# We're in a bindist

.PHONY: default
default:
	@echo 'Run "make install" to install'
	@false

.PHONY: install show
install show:
	$(MAKE) -r --no-print-directory -f ghc.mk $@ BINDIST=YES NO_INCLUDE_DEPS=YES

else

default : all
	@:

# For help, type 'make help'
.PHONY: help
help :
	@cat MAKEHELP

ifneq "$(findstring clean,$(MAKECMDGOALS))" ""
-include mk/config.mk
else
include mk/config.mk
ifeq "$(ProjectVersion)" ""
$(error Please run ./configure first)
endif
endif

include mk/custom-settings.mk

# Verify that stage 0 LLVM backend isn't affected by Bug #9439 if needed
ifeq "$(GHC_LLVM_AFFECTED_BY_9439)" "1"
ifneq "$(findstring -fllvm,$(GhcHcOpts) $(GhcStage1HcOpts))" ""
$(error Stage 0 compiler is affected by Bug #9439. Refusing to bootstrap with -fllvm)
endif
endif

# No need to update makefiles for these targets:
REALGOALS=$(filter-out binary-dist binary-dist-prep bootstrapping-files framework-pkg clean clean_% distclean maintainer-clean show echo help test fulltest,$(MAKECMDGOALS))

# configure touches certain files even if they haven't changed.  This
# can mean a lot of unnecessary recompilation after a re-configure, so
# here we cache the old versions of these files so we can restore the
# timestamps.
%.old:  %
	@set -x && test -f $@ && cmp -s $< $@ || cp -p $< $@
	touch -r $@ $<


# NB. not the same as saying '%: ...', which doesn't do the right thing:
# it does nothing if we specify a target that already exists.
.PHONY: $(REALGOALS)
$(REALGOALS) all: mk/config.mk.old mk/project.mk.old compiler/ghc.cabal.old
ifneq "$(OMIT_PHASE_0)" "YES"
	@echo "===--- building phase 0"
	$(MAKE) -r --no-print-directory -f ghc.mk phase=0 phase_0_builds
endif
ifneq "$(OMIT_PHASE_1)" "YES"
	@echo "===--- building phase 1"
	$(MAKE) -r --no-print-directory -f ghc.mk phase=1 phase_1_builds
endif
	@echo "===--- building final phase"
	$(MAKE) -r --no-print-directory -f ghc.mk phase=final $@

binary-dist: binary-dist-prep
	mv bindistprep/*.tar.$(TAR_COMP_EXT) .

binary-dist-prep:
ifeq "$(mingw32_TARGET_OS)" "1"
	$(MAKE) -r --no-print-directory -f ghc.mk windows-binary-dist-prep
else
	rm -f bindist-list
	$(MAKE) -r --no-print-directory -f ghc.mk bindist BINDIST=YES
	$(MAKE) -r --no-print-directory -f ghc.mk unix-binary-dist-prep
endif

clean distclean maintainer-clean:
	$(MAKE) -r --no-print-directory -f ghc.mk $@ CLEANING=YES
	test ! -d testsuite || $(MAKE) -C testsuite $@

$(filter clean_%, $(MAKECMDGOALS)) : clean_% :
	$(MAKE) -r --no-print-directory -f ghc.mk $@ CLEANING=YES

bootstrapping-files show echo:
	$(MAKE) -r --no-print-directory -f ghc.mk $@

ifeq "$(darwin_TARGET_OS)" "1"
framework-pkg:
	$(MAKE) -C distrib/MacOS $@
endif

# If the user says 'make A B', then we don't want to invoke two
# instances of the rule above in parallel:
.NOTPARALLEL:

endif

.PHONY: test
test:
	$(MAKE) -C testsuite/tests CLEANUP=1 OUTPUT_SUMMARY=../../testsuite_summary.txt fast

.PHONY: fulltest
fulltest:
	$(MAKE) -C testsuite/tests CLEANUP=1 OUTPUT_SUMMARY=../../testsuite_summary.txt

=== libffi/Makefile ===
--- 
+++ 
@@ -5,8 +5,8 @@
 # This file is part of the GHC build system.
 #
 # To understand how the build system works and how to modify it, see
-#      http://hackage.haskell.org/trac/ghc/wiki/Building/Architecture
-#      http://hackage.haskell.org/trac/ghc/wiki/Building/Modifying
+#      http://ghc.haskell.org/trac/ghc/wiki/Building/Architecture
+#      http://ghc.haskell.org/trac/ghc/wiki/Building/Modifying
 #
 # -----------------------------------------------------------------------------

=== libraries/time/Makefile ===
default: clean test install sdist

# Building

clean:
	cabal clean

configure:
	cabal configure --enable-library-profiling --enable-executable-profiling --enable-tests

build: configure
	cabal build --ghc-options=-Werror

test: build
	cabal test --test-option=--hide-successes --test-option=--color

haddock: configure
	cabal haddock

copy: build test haddock
	cabal copy

install:
	cabal install --user --ghc-options=-Werror --enable-library-profiling --enable-executable-profiling

sdist: clean configure
	cabal sdist

# switch off intermediate file deletion
.SECONDARY:

.PHONY: default clean configure build haddock copy install test sdist

=== utils/checkUniques/Makefile ===

GHC = ghc

PREL_NAMES = ../../compiler/prelude/PrelNames.lhs
DS_META = ../../compiler/deSugar/DsMeta.hs

.PHONY: check

check: checkUniques
	./checkUniques mkPreludeClassUnique   $(PREL_NAMES)
	./checkUniques mkPreludeTyConUnique   $(PREL_NAMES) $(DS_META)
	./checkUniques mkPreludeDataConUnique $(PREL_NAMES)
	./checkUniques mkPreludeMiscIdUnique  $(PREL_NAMES) $(DS_META)

checkUniques: checkUniques.hs
	$(GHC) --make $@

=== utils/debugNCG/Makefile ===
TOP=../..
include $(TOP)/mk/boilerplate.mk

INSTALL_PROGS += diff_gcc_nat

SRC_HC_OPTS += -O
OBJS = Diff_Gcc_Nat.o

CLEAN_FILES += diff_gcc_nat

all :: diff_gcc_nat

diff_gcc_nat: Diff_Gcc_Nat.o
	$(HC) -o $@ $(HC_OPTS) $(LD_OPTS) $(OBJS)

CLEAN_FILES += diff_gcc_nat
CLEAN_FILES += $(OBJS)

include $(TOP)/mk/target.mk

=== utils/heap-view/Makefile ===
TOP=../..
include $(TOP)/mk/boilerplate.mk

PROGRAMS = graph hpView hpView2

SRC_HC_OPTS += -hi-diffs -fglasgow-exts -fhaskell-1.3 -O -L/usr/X11/lib -cpp
SRC_CC_OPTS += -ansi -I/usr/X11/include
# ToDo: use AC_PATH_X in configure to get lib/include dirs for X.

OBJS_graph   = Graph.o           HaskXLib.o
OBJS_hpView  = HpView.o  Parse.o HaskXLib.o
OBJS_hpView2 = HpView2.o Parse.o HaskXLib.o

all :: $(PROGRAMS)

graph : $(OBJS_graph)
	$(HC) -o $@ $(HC_OPTS) $(LD_OPTS) $(OBJS_graph) -lX11

hpView : $(OBJS_hpView)
	$(HC) -o $@ $(HC_OPTS) $(LD_OPTS) $(OBJS_hpView) -lX11

hpView2 : $(OBJS_hpView2)
	$(HC) -o $@ $(HC_OPTS) $(LD_OPTS) $(OBJS_hpView2) -lX11

HaskXLib.o : HaskXLib.c
	$(CC) -c $(CC_OPTS) HaskXLib.c

INSTALL_PROGS += $(PROGRAMS)
CLEAN_FILES   += $(PROGRAMS)

include $(TOP)/mk/target.mk

=== libraries/Cabal/Cabal/Makefile ===

VERSION=1.18.1.5

#KIND=devel
KIND=rc
#KIND=cabal-latest

PREFIX=/usr/local
HC=ghc
GHCFLAGS=-Wall
SSH_USER=$USER

all: build

# build the library itself

SOURCES=Distribution/*.hs Distribution/Simple/*.hs Distribution/PackageDescription/*.hs Distribution/Simple/GHC/*.hs Distribution/Simple/Build/*.hs Distribution/Compat/*.hs Distribution/Simple/Program/*.hs
CONFIG_STAMP=dist/setup-config
BUILD_STAMP=dist/build/libHSCabal-$(VERSION).a
HADDOCK_STAMP=dist/doc/html/Cabal/index.html
USERGUIDE_STAMP=dist/doc/users-guide/index.html
SDIST_STAMP=dist/Cabal-$(VERSION).tar.gz
DISTLOC=dist/release
DIST_STAMP=$(DISTLOC)/Cabal-$(VERSION).tar.gz

COMMA=,

setup: $(SOURCES) Setup.hs
	-mkdir -p dist/setup
	$(HC) $(GHCFLAGS) --make -i. -odir dist/setup -hidir dist/setup Setup.hs -o setup

Setup-nhc:
	hmake -nhc98 -package base -prelude Setup

$(CONFIG_STAMP): setup Cabal.cabal
	./setup configure --with-compiler=$(HC) --prefix=$(PREFIX)

build: $(BUILD_STAMP)
$(BUILD_STAMP): $(CONFIG_STAMP) $(SOURCES)
	./setup build

install: $(BUILD_STAMP)
	./setup install

hugsbootstrap:
	rm -rf dist/tmp dist/hugs
	mkdir -p dist/tmp
	mkdir dist/hugs
	cp -r Distribution dist/tmp
	hugs-package dist/tmp dist/hugs
	cp Setup.lhs Cabal.cabal dist/hugs

hugsinstall: hugsbootstrap
	cd dist/hugs && ./Setup.lhs configure --hugs
	cd dist/hugs && ./Setup.lhs build
	cd dist/hugs && ./Setup.lhs install

# documentation...

haddock: $(HADDOCK_STAMP)
$(HADDOCK_STAMP) : $(CONFIG_STAMP) $(BUILD_STAMP)
	./setup haddock

PANDOC=pandoc
PANDOC_OPTIONS= \
	--standalone \
	--smart \
	--css=$(PANDOC_HTML_CSS)
PANDOC_HTML_OUTDIR=dist/doc/users-guide
PANDOC_HTML_CSS=Cabal.css

users-guide: $(USERGUIDE_STAMP) doc/*.markdown
$(USERGUIDE_STAMP): doc/*.markdown
	mkdir -p $(PANDOC_HTML_OUTDIR)
	for file in $^; do \
		[ $${file} != doc/index.markdown ] && TOC=--table-of-contents || TOC=; \
		$(PANDOC) $(PANDOC_OPTIONS) $${TOC} --from=markdown --to=html --output $(PANDOC_HTML_OUTDIR)/$$(basename $${file} .markdown).html $${file}; \
	done
	cp doc/$(PANDOC_HTML_CSS) $(PANDOC_HTML_OUTDIR)

docs: haddock users-guide

clean:
	rm -rf dist/
	rm -f setup

# testing...

moduleTest: tests/ModuleTest.hs tests/PackageDescriptionTests.hs
	mkdir -p dist/test
	$(HC) --make -Wall -DDEBUG -odir dist/test -hidir dist/test \
		-itests tests/ModuleTest.hs -o moduleTest

#tests: moduleTest clean
#	cd tests/A && $(MAKE) clean
#	cd tests/HUnit-1.0 && $(MAKE) clean
#	cd tests/A && $(MAKE)
#	cd tests/HUnit-1.0 && $(MAKE)

#check:
#	rm -f moduleTest
#	$(MAKE) moduleTest
#	./moduleTest

# distribution...

$(SDIST_STAMP) : $(BUILD_STAMP)
	./setup sdist

dist: $(DIST_STAMP)
$(DIST_STAMP) : $(HADDOCK_STAMP) $(USERGUIDE_STAMP) $(SDIST_STAMP)
	rm -rf $(DISTLOC)
	mkdir $(DISTLOC)
	tar -xzf $(SDIST_STAMP) -C $(DISTLOC)/
	mkdir $(DISTLOC)/Cabal-$(VERSION)/doc
	cp -r dist/doc/html $(DISTLOC)/Cabal-$(VERSION)/doc/API
	cp -r dist/doc/users-guide $(DISTLOC)/Cabal-$(VERSION)/doc/
	cp changelog $(DISTLOC)/Cabal-$(VERSION)/
	tar -C $(DISTLOC) -czf $(DISTLOC)/Cabal-$(VERSION).tar.gz Cabal-$(VERSION)
	mv $(DISTLOC)/Cabal-$(VERSION)/doc $(DISTLOC)/
	mv $(DISTLOC)/Cabal-$(VERSION)/changelog $(DISTLOC)/
	rm -r $(DISTLOC)/Cabal-$(VERSION)/
	@echo "Cabal tarball built: $(DIST_STAMP)"
	@echo "Release fileset prepared: $(DISTLOC)/"

release: $(DIST_STAMP)
	scp -r $(DISTLOC) $(SSH_USER)@haskell.org:/home/web/haskell.org/cabal/release/cabal-$(VERSION)
	ssh $(SSH_USER)@haskell.org 'cd /home/web/haskell.org/cabal/release && rm -f $(KIND) && ln -s cabal-$(VERSION) $(KIND)'

# tags...

TAGSSRCDIRS = Distribution Language
tags TAGS: $(SOURCES)
	find $(TAGSSRCDIRS) -name \*.\*hs | xargs hasktags

=== libraries/binary/benchmarks/Makefile ===
ghc := ghc
ghc-flags :=
programs := builder bench

SYSTEM_BINARY := binary-0.5.1.1

.PHONY: all
all: $(programs)

builder: Builder.hs
	$(ghc) $(ghc-flags) --make -O2 Builder.hs -o $@ -fforce-recomp -i../src

get: Get.hs
	$(ghc) $(ghc-flags) --make -O2 Get.hs -o $@ -fforce-recomp -i../src

system-get: Get.hs
	$(ghc) $(ghc-flags) --make -O2 Get.hs -o $@ -package $(SYSTEM_BINARY)

bench: Benchmark.hs MemBench.hs CBenchmark.o
	$(ghc) $(ghc-flags) --make -O2 -fliberate-case-threshold=1000 Benchmark.hs CBenchmark.o -o $@ -fforce-recomp -i../src

system-bench: Benchmark.hs MemBench.hs CBenchmark.o
	$(ghc) $(ghc-flags) --make -O2 -fliberate-case-threshold=1000 Benchmark.hs CBenchmark.o -o $@ -no-user-package-conf

.PHONY: run-bench
run-bench: bench
	./bench 100

CBenchmark.o: CBenchmark.c
	$(ghc) -c -optc -O3 $< -o $@

.PHONY: clean
clean:
	rm -f *.o *.hi $(programs)

=== libraries/binary/tests/Makefile ===
ghc := ghc
ghc-flags := 

all: compiled

interpreted:
	runhaskell QC.hs 1000

compiled:
	$(ghc) --make -fhpc -O QC.hs -o qc -fforce-recomp -threaded -rtsopts -i../src -XCPP -package test-framework -package test-framework-quickcheck2 $(ghc-flags)
	rm -f qc.tix
	./qc --maximum-generated-tests=1000 -j2 +RTS -N2

hugs:
	runhugs -98 QC.hs  

clean:
	rm -f *.o *.hi qc *.tix *~

.PHONY: clean

=== libraries/filepath/tests/Makefile ===
# This Makefile runs the tests using GHC's testsuite framework.  It
# assumes the package is part of a GHC build tree with the testsuite
# installed in ../../../testsuite.

TOP=../../../testsuite
include $(TOP)/mk/boilerplate.mk
include $(TOP)/mk/test.mk

.PHONY: ghc-filepath-tests
ghc-filepath-tests:
	$(RM) -f GenTests.hi GenTests.o GenTests GenTests.exe
	$(RM) -f AutoTest.hi AutoTest.o
	$(RM) -f FilePath_Test.hs
	$(RM) -f FilePath_Test.hi FilePath_Test.o FilePath_Test FilePath_Test.exe
	'$(TEST_HC)' $(TEST_HC_OPTS) -v0 --make GenTests
	./GenTests
	'$(TEST_HC)' $(TEST_HC_OPTS) -v0 --make FilePath_Test
	./FilePath_Test

=== libraries/integer-gmp/mkGmpDerivedConstants/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Architecture
#      http://hackage.haskell.org/trac/ghc/wiki/Building/Modifying
#
# -----------------------------------------------------------------------------

dir = libraries/integer-gmp/mkGmpDerivedConstants
TOP = ../../..
include $(TOP)/mk/sub-makefile.mk

=== debian/rules ===
--- 
+++ 
@@ -8,11 +8,11 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-# Set default flags with dpkg-buildflags
-# This might also close #712228
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk
+# # Set default flags with dpkg-buildflags
+# # This might also close #712228
+# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+# DPKG_EXPORT_BUILDFLAGS = 1
+# include /usr/share/dpkg/buildflags.mk
 
 # Set a dummy HOME variable upon build. Some build daemons do not set HOME, but
 # ghc-cabal expects it to be available.
@@ -45,21 +45,17 @@
 configure: configure-stamp
 configure-stamp:
 	dh_testdir
-	dh_autoreconf
+	dh_autoreconf perl -- boot
 
 	rm -f mk/build.mk
 	echo "SRC_HC_OPTS += -lffi -optl-pthread" >> mk/build.mk
 	echo "HADDOCK_DOCS := YES" >> mk/build.mk
 	echo "XSLTPROC_OPTS += --nonet" >> mk/build.mk
-ifneq (,$(findstring $(DEB_HOST_ARCH), arm armel armhf))
-	echo "SRC_HC_OPTS     += -optc-mlong-calls" >> mk/build.mk
+ifneq (,$(findstring $(DEB_HOST_ARCH), arm64 armel armhf))
+	echo "SRC_HC_OPTS     += -optl-B/usr/bin/ld.gold" >> mk/build.mk
 endif
 ifeq (armhf,$(DEB_HOST_ARCH))
 	echo "SRC_HC_OPTS += -D__ARM_PCS_VFP" >> mk/build.mk
-endif
-# proper fix for #360177
-ifeq (ppc64,$(DEB_HOST_ARCH))
-	echo "SRC_HC_OPTS += -optc-mminimal-toc" >> mk/build.mk
 endif
 ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
 #	echo "GhcStage1HcOpts += -DDEBUG" >> mk/build.mk
@@ -80,17 +76,11 @@
 	# We also want to build the threaded profiling-enabled debug runtime,
 	# because it does no harm
 	echo 'GhcRTSWays += $$(if $$(findstring p, $$(GhcLibWays)),thr_debug_p,)' >> mk/build.mk
-ifneq (,$(findstring $(DEB_HOST_ARCH),armel armhf))
-	# GHCi is too badly broken on ARM; see
-	# http://hackage.haskell.org/trac/ghc/ticket/7794
-	echo "GhcWithInterpreter = NO" >> mk/build.mk
-endif
-	
+
 	# We can't do this with a configure flag in 6.8.1 as libdir is not
 	# defined at the point at which we := it
 	echo 'ghclibdir := $${libdir}/ghc' >> mk/build.mk
-	echo 'bindir  := $${ghclibdir}/bin' >> mk/build.mk
-	echo 'ghclibexecdir := $${ghclibdir}/lib' >> mk/build.mk
+	echo 'bindir  := /usr/bin' >> mk/build.mk
 	# docdir doesn't have a configure flag, and unfortunately
 	# we also need to explicitly define all of its dependents as they
 	# are set with :=
@@ -107,9 +97,9 @@
 	ln -s /usr/share/misc/config.guess .
 	./configure $(confflags) --prefix=/usr \
 		$(EXTRA_CONFIGURE_FLAGS) \
-		--with-ld=ld.bfd \
-		--with-llc=llc \
-		--with-opt=opt
+		--with-system-libffi \
+		--with-llc=llc-3.4 \
+		--with-opt=opt-3.4
 
 	touch $@
 
@@ -131,6 +121,7 @@
 	rm debian/testghc/*
 
 # build haddock separately and hard code paths according to install paths
+	rm -rf debian/haddock-build
 	mkdir -p debian/haddock-build
 	cp -r utils/haddock debian/haddock-build
 	cd debian/haddock-build/haddock; \
@@ -138,14 +129,17 @@
 		../../../inplace/bin/ghc-stage2 --make Setup.lhs; \
 		./Setup configure --prefix=/usr --with-compiler=../../../inplace/bin/ghc-stage2 \
 			--package-db=../../../inplace/lib/package.conf.d/ \
-			--htmldir=/usr/share/doc/ghc-haddock/html/ ; \
+			--htmldir=/usr/share/doc/ghc-haddock/html/ \
+			--datadir=/usr/share \
+			--datasubdir=haddock \
+			--libdir=/usr/lib \
+			--libsubdir=haddock  ; \
 		./Setup build
 
 	touch $@
 
 FILES = \( -type f -o -type l \)
 PROF_FILE = \( -name "*.p_*" -o -name "lib*_p.a" \)
-DYNAMIC_FILE = \( -name "*.dyn_hi" -o -name lib*.so \)
 
 install: install-stamp
 install-stamp: build-stamp
@@ -159,11 +153,15 @@
 	# Delete all the library LICENSE files
 	rm -f debian/tmp/usr/share/doc/ghc-doc/html/libraries/*/LICENSE
 
+	# Remove the haddock.t files, they really should not be in the released
+	# package (upstream #10410)
+	find debian/tmp -name \*.haddock.t -delete
+
 	# Generate lintian overrides
 	mkdir -p debian/tmp/usr/share/lintian/overrides
-	echo "ghc binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc-*/Cabal-*/Distribution/License.hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
-	echo "ghc: extra-license-file `cl debian/tmp && echo usr/lib/ghc-*/Cabal-*/Distribution/License.dyn_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
-	echo "ghc-prof binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc-*/Cabal-*/Distribution/License.p_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc-prof
+	echo "ghc binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc/Cabal-*/Distribution/License.hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
+	echo "ghc: extra-license-file `cd debian/tmp && echo usr/lib/ghc/Cabal-*/Distribution/License.dyn_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
+	echo "ghc-prof binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc/Cabal-*/Distribution/License.p_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc-prof
 
 	# Sort out the package.conf files
 	mkdir -p debian/tmp/var/lib/ghc
@@ -173,30 +171,31 @@
 	rm debian/tmp/var/lib/ghc/package.conf.d/package.cache
 	chmod +x debian/provided_substvars
 	debian/provided_substvars
-	sed -ri 's,^haddock-interfaces: /.*?/libraries/,haddock-interfaces: /usr/lib/ghc-doc/haddock/,' debian/tmp/var/lib/ghc/package.conf.d/*.conf
+	sed -ri 's,^haddock-interfaces: /.*?/libraries/,haddock-interfaces: /usr/lib/ghc-doc/haddock/ghc/,' debian/tmp/var/lib/ghc/package.conf.d/*.conf
 
 	# Remove haddock as built within the ghc tree
-	rm -f debian/tmp/usr/lib/ghc/bin/haddock \
-	      debian/tmp/usr/lib/ghc/bin/haddock-$(ProjectVersion) \
+	rm -f debian/tmp/usr/bin/haddock \
+	      debian/tmp/usr/bin/haddock-$(ProjectVersion) \
 	      debian/tmp/usr/lib/ghc/lib/haddock
 	rm -rf debian/tmp/usr/lib/ghc/html
 
 	# Sort out the binaries
-	mkdir -p debian/tmp/usr/bin
 	if inplace/bin/ghc-stage2 --info | grep '"Have interpreter","NO"'; then \
-	    cd debian/tmp/usr/lib/ghc ;rm -f bin/ghci* bin/runghc* bin/runhaskell*; \
+	    cd debian/tmp/usr/bin ;rm -f ghci* runghc* runhaskell*; \
 	fi
-	cd debian/tmp/usr/lib/ghc/bin && \
-	    for f in *; \
-	    do ln -s /usr/lib/ghc/bin/$$f \
-	             ../../../bin/$${f}; \
-	    done
-	sed -i 's,topdir="/usr/lib,topdir="/var/lib,' debian/tmp/usr/lib/ghc/bin/ghc-pkg-$(ProjectVersion)
 	cd debian/haddock-build/haddock; ./Setup copy --dest=../../tmp
 
 	# Check if we have a ghci binary
-	if test -e debian/tmp/usr/lib/ghc/bin/ghci-$(ProjectVersion); then \
+	if test -e debian/tmp/usr/bin/ghci-$(ProjectVersion); then \
 	    echo 'ghci=ghc-ghci' >> debian/ghc.substvars ; fi
 
 	# Add haddock substvars
 	echo "haddock:Depends=haddock-interface-$$(debian/tmp/usr/bin/haddock --interface-version)" >> debian/ghc-doc.substvars
+	echo "haddock:Provides=haddock-interface-$$(debian/tmp/usr/bin/haddock --interface-version)" >> debian/ghc-haddock.substvars
+
+ifeq (YES,$(BUILD_HADDOCK_DOCS))
+	mkdir -p debian/tmp/usr/lib/ghc-doc
+	cp debian/gen_contents_index debian/tmp/usr/lib/ghc-doc/
+	chmod +x debian/tmp/usr/lib/ghc-doc/gen_contents_index
+	mkdir debian/tmp/usr/lib/ghc-doc/haddock
+	mkdir debian/tmp/usr/lib/ghc-doc/haddock/ghc/

=== debian/watch ===
version=3
http://downloads.haskell.org/~ghc/(\d[\d.]*)/ghc-(\d[\d.]*)-src.tar.bz2
